Open CASCADE Technology: SelectMgr_SelectableObjectSet Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
SelectMgr_SelectableObjectSet Class Reference

The purpose of this class is to organize all selectable objects into data structure, allowing to build BVH tree. For selectable objects binned BVH builder is used with 32 bins and 1 element per leaf. More...

`#include <SelectMgr_SelectableObjectSet.hxx>`

Inheritance diagram for SelectMgr_SelectableObjectSet:
[legend]

## Public Member Functions
| SelectMgr_SelectableObjectSet ()
| Creates new empty objects set and initializes BVH tree builder to Binned builder with 1 element per list. More...
virtual | ~SelectMgr_SelectableObjectSet ()
| Releases resources of selectable object set. More...
void | Append (const Handle< SelectMgr_SelectableObject > &theObject)
| Adds new object to the set and marks BVH tree for rebuild. More...
void | Remove (const Handle< SelectMgr_SelectableObject > &theObject)
| Removes object theObject from set and marks BVH tree for rebuild. More...
virtual Select3D_BndBox3d | Box (const Standard_Integer theIndex) const Standard_OVERRIDE
| Returns bounding box of object with index theIndex. More...
virtual Standard_Real | Center (const Standard_Integer theIndex, const Standard_Integer theAxis) const Standard_OVERRIDE
| Returns center of object with index theIndex in the set along the given axis theAxis. More...
virtual void | Swap (const Standard_Integer theIndex1, const Standard_Integer theIndex2) Standard_OVERRIDE
| Swaps items with indexes theIndex1 and theIndex2 in the set. More...
virtual Standard_Integer | Size () const Standard_OVERRIDE
| Returns size of objects set. More...
const Handle< SelectMgr_SelectableObject > & | GetObjectById (const Standard_Integer theIndex) const
| Returns object from set by theIndex given. More...
Standard_Boolean | Contains (const Handle< SelectMgr_SelectableObject > &theObject) const
| Returns true if this objects set contains theObject given. More...
Public Member Functions inherited from BVH_PrimitiveSet< Standard_Real, 3 >
| BVH_PrimitiveSet ()
| Creates set of abstract primitives. More...
virtual | ~BVH_PrimitiveSet ()
| Releases resources of set of abstract primitives. More...
virtual BVH_Box< Standard_Real, N > | Box () const
| Returns AABB of primitive set. More...
virtual const NCollection_Handle< BVH_Tree< Standard_Real, N > > & | BVH ()
| Returns BVH tree (and builds it if necessary). More...
virtual const NCollection_Handle< BVH_Builder< Standard_Real, N > > & | Builder () const
| Returns the method (builder) used to construct BVH. More...
virtual void | SetBuilder (NCollection_Handle< BVH_Builder< Standard_Real, N > > &theBuilder)
| Sets the method (builder) used to construct BVH. More...
Public Member Functions inherited from BVH_Object< Standard_Real, N >
| BVH_Object ()
| Creates new abstract geometric object. More...
virtual | ~BVH_Object ()=0
| Releases resources of geometric object. More...
virtual const NCollection_Handle< BVH_Properties > & | Properties () const
| Returns properties of the geometric object. More...
virtual void | SetProperties (const NCollection_Handle< BVH_Properties > &theProperties)
| Sets properties of the geometric object. More...
virtual void | MarkDirty ()
| Marks object state as outdated (needs BVH rebuilding). More...
Public Member Functions inherited from BVH_Set< Standard_Real, N >
| BVH_Set ()
| Creates new abstract set of objects. More...
virtual | ~BVH_Set ()=0
| Releases resources of set of objects. More...

## Additional Inherited Members
Public Types inherited from BVH_Set< Standard_Real, N >
typedef BVH_Box< Standard_Real, N > | BVH_BoxNt
Protected Member Functions inherited from BVH_PrimitiveSet< Standard_Real, 3 >
virtual void | Update ()
| Updates BVH of primitive set. More...
Protected Attributes inherited from BVH_PrimitiveSet< Standard_Real, 3 >
NCollection_Handle< BVH_Tree< Standard_Real, N > > | myBVH
| Constructed bottom-level BVH. More...
NCollection_Handle< BVH_Builder< Standard_Real, N > > | myBuilder
| Builder for bottom-level BVH. More...
BVH_Box< Standard_Real, N > | myBox
| Cached bounding box of geometric primitives. More...
Protected Attributes inherited from BVH_Object< Standard_Real, N >
Standard_Boolean | myIsDirty
| Marks internal object state as outdated. More...
NCollection_Handle< BVH_Properties > | myProperties
| Generic properties assigned to the object. More...

## Detailed Description

The purpose of this class is to organize all selectable objects into data structure, allowing to build BVH tree. For selectable objects binned BVH builder is used with 32 bins and 1 element per leaf.

## Constructor & Destructor Documentation

SelectMgr_SelectableObjectSet::SelectMgr_SelectableObjectSet | ( |  | ) |

Creates new empty objects set and initializes BVH tree builder to Binned builder with 1 element per list.

virtual SelectMgr_SelectableObjectSet::~SelectMgr_SelectableObjectSet | ( |  | ) |
| inlinevirtual

Releases resources of selectable object set.

## Member Function Documentation

void SelectMgr_SelectableObjectSet::Append | ( | const Handle< SelectMgr_SelectableObject > & | theObject | ) |

Adds new object to the set and marks BVH tree for rebuild.

virtual Select3D_BndBox3d SelectMgr_SelectableObjectSet::Box | ( | const Standard_Integer | theIndex | ) | const
| virtual

Returns bounding box of object with index theIndex.

Implements BVH_Set< Standard_Real, N >.

virtual Standard_Real SelectMgr_SelectableObjectSet::Center | ( | const Standard_Integer | theIndex,
|  | const Standard_Integer | theAxis
| ) |  | const
| virtual

Returns center of object with index theIndex in the set along the given axis theAxis.

Implements BVH_Set< Standard_Real, N >.

Standard_Boolean SelectMgr_SelectableObjectSet::Contains | ( | const Handle< SelectMgr_SelectableObject > & | theObject | ) | const

Returns true if this objects set contains theObject given.

const Handle< SelectMgr_SelectableObject >& SelectMgr_SelectableObjectSet::GetObjectById | ( | const Standard_Integer | theIndex | ) | const

Returns object from set by theIndex given.

void SelectMgr_SelectableObjectSet::Remove | ( | const Handle< SelectMgr_SelectableObject > & | theObject | ) |

Removes object theObject from set and marks BVH tree for rebuild.

virtual Standard_Integer SelectMgr_SelectableObjectSet::Size | ( |  | ) | const
| virtual

Returns size of objects set.

Implements BVH_Set< Standard_Real, N >.

virtual void SelectMgr_SelectableObjectSet::Swap | ( | const Standard_Integer | theIndex1,
|  | const Standard_Integer | theIndex2
| ) |  |
| virtual

Swaps items with indexes theIndex1 and theIndex2 in the set.

Implements BVH_Set< Standard_Real, N >.

The documentation for this class was generated from the following file:

- SelectMgr_SelectableObjectSet.hxx